/*******************************************************************
 * Data Visualization - Depression, Melancholia, Boredom, Tedium    *
 * Tested in Processing 3                                           *     
 *                                                                  *
 * Author: Yichen Li                                                *
 * Supervisor: George Legrady                                       *
 * Supervisor: Rodger Luo                                           *
 *                                                                  *
 * Reference: Heavily based on Rodger's Basic3D code and accompany- *
 *            ing classes and functions.                            *
 * Purpose: Demonstrate the checkout behavior and keep duration of  *
 books with titles containing variations of words        *
 "depression", "melancholia", "boredom", and "tedium"    *
 *          Visualized with different color schemes.                * 
 *******************************************************************/
//commented out text, sphere
import peasy.*;
import controlP5.*;
PeasyCam cam;
ControlP5 cp5;


Table table;
int numRows, numColumns;
String listcheckoutdays;
int z;
String wordchosen;

//Book book = new Book();

ArrayList<Checkout> checkouts = new ArrayList<Checkout>();

void setup() {
//----- setup -------------//
  wordchosen = "";
  fullScreen(P3D);
  //size(1000, 1000, P3D);
  cam = new PeasyCam(this, 200);
  cp5 = new ControlP5(this);
  cp5.addButton("button", 10, 100, 60, 80, 20).setId(1);
  cp5.addButton("buttonValue", 4, 100, 90, 80, 20).setId(2);
  cp5.setAutoDraw(false);
  cam.setYawRotationMode();
  //cam.rotateY(-PI/2);
  //cam.lookAt(-500,0,-500);
  cam.setMaximumDistance(1000);
  //Added on Jan 30th by Rodger Luo
  float  cameraZ = (height/2.0) / tan(PI*60.0/360.0);
  perspective(PI/3, width/height, 0.01, cameraZ*100); 
  table = loadTable("reducedrows.csv", "header");
  numRows = table.getRowCount();
  println("Rows: " + numRows);
  PFont font;
  font =createFont("Futura-Medium.ttf", 32);
  textMode(SHAPE);
  textFont(font);
  
  for (int i=0; i<numRows; i++) {
    String title= table.getString(i, 0);
    String word = table.getString(i, 13);
    int cout_month = table.getInt(i, 6);
    //cout_month ranges from 1 to 12
    int cout_day = table.getInt(i, 7);
    //cout_day ranges from 1 to 31
    int cout_hour = table.getInt(i, 8);
    //cout_hour ranges from 10 to 20 
    int cin_month = table.getInt(i, 9);
    int cin_day = table.getInt(i, 11);
    int cin_hour = table.getInt(i, 12);
    float DayHourAxis_cout = map(cout_day*11+cout_hour, 21, 361, -20, 20);
    float DayHourAxis_cin = map(cin_day*11+cin_hour, 21, 361, -20, 20);
    float MonthDayAxis_cout = map(cout_month*31+cout_day, 32, 373, -20, 20);
    float MonthDayAxis_cin = map(cin_month*31+cin_day, 32, 373, -20, 20);
    float HourAxis_cout = map(cout_hour, 10, 20, -20, 20);
    float HourAxis_cin = map(cin_hour, 10, 20, -20, 20);
    IntList same_title_checkout = new IntList();

    checkouts.add(new Checkout(word, title, cout_day, cout_month, cout_hour, cin_day, cin_month, cin_hour, same_title_checkout, DayHourAxis_cout, DayHourAxis_cin, MonthDayAxis_cout, MonthDayAxis_cin, HourAxis_cout, HourAxis_cin));
  }
  // doesn't work?
  for (int i=0; i<checkouts.size(); i++) {
    IntList sametitles = new IntList();;
    for (int j=0; j<checkouts.size(); j++) {
      if (checkouts.get(j).title.equals(checkouts.get(i).title)) {
        sametitles.append(j);
        println(checkouts.get(j).title);
      }
      checkouts.get(i).same_title_checkout = sametitles;
      //println(checkouts.get(i).same_title_checkout);
    }
  }
}

void draw() {
  background(255); 
//------ draw titles------------------//
  cam.beginHUD();
  textMode(SHAPE);
  fill(255,0,0);
  textAlign(LEFT,TOP);
  textSize(40);
  fill(0);
  text("winterblues", 10, 10);
  strokeWeight(2);
  line(10,65,500,65);
  textSize(20);
  text("titles relating to depression, anxiety, tedium, boredom", 10, 70);
  textSize(15);
  textLeading(20);
  text("hoover over point to view title, checkout dates\nlines connect checkout instances of same title\npress 'd' -> depression\npress 'a' -> boredom\npress 'e' -> tedium\npress 'q' -> melancholia\ncmd + shift to shift camera\ncmd + shift to shift camera", 10, 100);
  
  cam.endHUD();
 
//------ draw each point-------------//
  for (int i=0; i<checkouts.size(); i++) {
    color c = wordDetermine(checkouts.get(i).word);
    int o = wordDetermineOffSet(checkouts.get(i).word);
    pushMatrix();
    rotateY(PI/2.0);
    translate(11*(checkouts.get(i).MonthDayAxis_cout+checkouts.get(i).DayHourAxis_cout)+o, 
      -2*abs(checkouts.get(i).MonthDayAxis_cin-checkouts.get(i).MonthDayAxis_cout), 
      2*checkouts.get(i).MonthDayAxis_cout*11+checkouts.get(i).DayHourAxis_cout*11+checkouts.get(i).HourAxis_cout);
    strokeWeight(5);
    stroke(c);
    point(0, 0, 0);
    fill(c);
    strokeWeight(2);
 
//------ mouse hoover actions ---------//
    PVector mouse_pos = new PVector(mouseX,mouseY);
    PVector screen_pos = new PVector(screenX(0,0,0),screenY(0,0,0));
    float mouseObjectDist = mouse_pos.dist(screen_pos);
    if(mouseObjectDist < 2){
      cam.beginHUD();
      strokeWeight(5);
      textSize(20);
      textAlign(LEFT,BOTTOM);
      //NOTE: need to write if length of showtext is larger than 1 to display
      //empty titles as "written in non-latin alphabet"
      fill(c);
      text("TITLE:  " + checkouts.get(i).title,10,700);
      cam.endHUD();
      strokeWeight(10);
      point(0,0,0);
      fill(255);
      textSize(30);
      if (checkouts.get(i).same_title_checkout.size()>0) {
        beginShape();
        noFill();
        strokeWeight(0.5);
        stroke(c);
        curveVertex(0, 0, 0);
        for (int k=0; k<checkouts.get(i).same_title_checkout.size(); k++) {
          curveVertex(11*(checkouts.get(k).MonthDayAxis_cout-checkouts.get(i).MonthDayAxis_cout+checkouts.get(k).DayHourAxis_cout-checkouts.get(i).DayHourAxis_cout)+o,
          -2*(checkouts.get(k).MonthDayAxis_cin-checkouts.get(i).MonthDayAxis_cin- checkouts.get(k).MonthDayAxis_cout + checkouts.get(i).MonthDayAxis_cout+ checkouts.get(k).DayHourAxis_cin-checkouts.get(i).DayHourAxis_cin- checkouts.get(k).DayHourAxis_cout + checkouts.get(i).DayHourAxis_cout),
          2*(checkouts.get(k).MonthDayAxis_cout*11 - checkouts.get(i).MonthDayAxis_cout*11+ checkouts.get(k).DayHourAxis_cout*11 -checkouts.get(i).DayHourAxis_cout*11+ checkouts.get(k).HourAxis_cout - checkouts.get(i).HourAxis_cout));
          curveVertex(11*(checkouts.get(k).MonthDayAxis_cout-checkouts.get(i).MonthDayAxis_cout+checkouts.get(k).DayHourAxis_cout-checkouts.get(i).DayHourAxis_cout)+o, 
            -2*(checkouts.get(k).MonthDayAxis_cin-checkouts.get(i).MonthDayAxis_cin- checkouts.get(k).MonthDayAxis_cout + checkouts.get(i).MonthDayAxis_cout), 
            2*(checkouts.get(k).MonthDayAxis_cout*11 - checkouts.get(i).MonthDayAxis_cout*11+ checkouts.get(k).DayHourAxis_cout*11 -checkouts.get(i).DayHourAxis_cout*11+ checkouts.get(k).HourAxis_cout - checkouts.get(i).HourAxis_cout));
           listcheckoutdays += (checkouts.get(k).cout_month + "/" + checkouts.get(k).cout_day + "\n");
          }
          endShape();
          cam.beginHUD();
          strokeWeight(5);
          fill(255,0,0);
          textAlign(LEFT,BOTTOM);
          textSize(10);
          text("CHECKOUTS: " + listcheckoutdays, 500, 700);
          cam.endHUD();
        }
      }
      z = i;
//-------- key press action --------//
      if (checkouts.get(z).word.equals(wordchosen) == true){
        print(checkouts.get(z).word);
        beginShape();
        strokeWeight(0.5);
        fill(200,10);
        curveVertex(0,0,0);
        for (int k=0; k<checkouts.get(z).same_title_checkout.size(); k++) {
          curveVertex(11*(checkouts.get(k).MonthDayAxis_cout-checkouts.get(z).MonthDayAxis_cout+checkouts.get(k).DayHourAxis_cout-checkouts.get(z).DayHourAxis_cout)+o,
          -2*(checkouts.get(k).MonthDayAxis_cin-checkouts.get(z).MonthDayAxis_cin- checkouts.get(k).MonthDayAxis_cout + checkouts.get(z).MonthDayAxis_cout+ checkouts.get(k).DayHourAxis_cin-checkouts.get(z).DayHourAxis_cin- checkouts.get(k).DayHourAxis_cout + checkouts.get(z).DayHourAxis_cout),
          2*(checkouts.get(k).MonthDayAxis_cout*11 - checkouts.get(z).MonthDayAxis_cout*11+ checkouts.get(k).DayHourAxis_cout*11 -checkouts.get(z).DayHourAxis_cout*11+ checkouts.get(k).HourAxis_cout - checkouts.get(z).HourAxis_cout));
          curveVertex(11*(checkouts.get(k).MonthDayAxis_cout-checkouts.get(z).MonthDayAxis_cout+checkouts.get(k).DayHourAxis_cout-checkouts.get(z).DayHourAxis_cout)+o, 
            -2*(checkouts.get(k).MonthDayAxis_cin-checkouts.get(z).MonthDayAxis_cin- checkouts.get(k).MonthDayAxis_cout + checkouts.get(z).MonthDayAxis_cout), 
            2*(checkouts.get(k).MonthDayAxis_cout*11 - checkouts.get(z).MonthDayAxis_cout*11+ checkouts.get(k).DayHourAxis_cout*11 -checkouts.get(z).DayHourAxis_cout*11+ checkouts.get(k).HourAxis_cout - checkouts.get(z).HourAxis_cout));
            listcheckoutdays += (checkouts.get(k).cout_month + "/" + checkouts.get(k).cout_day + "\n");
          }
          endShape();
          cam.beginHUD();
          textMode(SHAPE);
          strokeWeight(5);
          fill(0);
          textAlign(LEFT,BOTTOM);
          textSize(20);
          text("TITLES MENTIONING: " + wordchosen, 10, 600);
          cam.endHUD();
      }
      popMatrix();
    }
    save("depression.png");
  }

void keyPressed() {
  if ( key == 'd') {
    wordchosen = "depression";
  } else if (key == 'e'){
    wordchosen = "tedium";
  } else if (key == 'q'){
    wordchosen = "melancholia";
  } else if (key == 'a'){
    wordchosen = "boredom";
  }
}
